
#include "config_and_coord.h"

void print_macros(){
  int worldsize = N_WORLD_SIZE * N_WORLD_SIZE;
  printf("Max. Population: %f, Optimal Population: %f, Death rate: %f, Sigmoid slope: %f\n", MAX_POPULATION_PER_FIELD, OPTIMAL_POPULATION_PER_FIELD, DEATH_RATE, SIGMOID_SLOPE);
  printf("World-size: %d, Initial Population size: %d\n", worldsize, INITIAL_POPULATION_SIZE);
  return;
}

coordinate_list* new_coord_list(int size){
  coordinate_list * list = malloc(sizeof(coordinate_list));
  list->size = size;
  list->entries = 0;
  list->x = malloc(size*sizeof(int));
  list->y = malloc(size*sizeof(int));
  return(list);
}

void delete_coord_list(coordinate_list*list){
  free(list->x);
  free(list->y);
  free(list);
  return;
}

void resize_coord_list(coordinate_list* list){
  list->size*=2;
  list->x = realloc( list->x, list->size*sizeof(int*));
  list->y = realloc( list->y, list->size*sizeof(int*));
  return;
}

void add_2_coord_list(coordinate_list* list, int x, int y){
  if(list->size == list->entries) resize_coord_list(list);
  list->x[list->entries] = x;
  list->y[list->entries] = y;
  list->entries++;
  return;
}
