
#ifndef CONFIG_AND_COORD_H 
#define CONFIG_AND_COORD_H

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

//death by overpopulation
#define MAX_POPULATION_PER_FIELD 10.0
#define OPTIMAL_POPULATION_PER_FIELD 1.0
#define DEATH_COEFFICIENT 2
#define DEATH_RATE 1.0
#define SIGMOID_SLOPE 2.0

//how many children from one birth
#define MAX_CHILDREN 2
#define MIN_CHILDREN 0

#define MAX_CHILDREN_MUTANT 4 
#define MIN_CHILDREN_MUTANT 0

//death by age
#define MAX_AGE 1000
#define MAX_AGE_MUTANT 1400
#define DEATH_CONST 0.99

//adult age, pregnancy time ..
#define ADULT_AGE_MALE 200
#define ADULT_AGE_FEMALE ADULT_AGE_MALE
#define PREGNANCY_TIME 9

//genetic framework
#define CHROMOSOMES_HAPLOID 4
#define CHROMOSOMES_DIPLOID (2*CHROMOSOMES_HAPLOID)
#define GENES_ON_AUTOSOMES 1
#define GENES_ON_GONOSOMES 1

#define NR_PHENOTYPES 16

#define PROB_REC 0.3

//different phenotypes and their gene numbers
#define MORE_CHILDREN 1
#define LONG_LIVE 2
#define BETTER_SURVIVE 3

#define BETTER_SURVIVAL_FACTOR 1

// memory allocation constant
#define LIST_INIT_SIZE 100

//factors for main function / simulation
#define N_WORLD_SIZE 10
#define INITIAL_POPULATION_SIZE (N_WORLD_SIZE * N_WORLD_SIZE / 5)
#define RESOLUTION 2
#define RUNS 3000

#define STEPS_2_BMP 100

void print_macros();

typedef struct{
  int size;
  int entries;
  int*x;
  int*y;
}coordinate_list;
 
coordinate_list* new_coord_list(int size);

void delete_coord_list(coordinate_list*list);

void add_2_coord_list(coordinate_list* list, int x, int y);

#endif
