
#include "parallel_org.h"
 
train * build_a_train(){
  int i;
  train * tgv = malloc(sizeof(train));
  for(i=0; i<8; i++){
    tgv->size[i] = 1;
    tgv->nr_passengers[i] = 0;
    tgv->passengers[i] = malloc( INITIAL_TRAIN_SIZE*sizeof(organism) );
  }
  return(tgv);
}
 
void resize_train(train * tgv, int wagon){
  tgv->size[wagon]++;
  tgv->passengers[wagon] = realloc(tgv->passengers[wagon], tgv->size[wagon]*INITIAL_TRAIN_SIZE*sizeof(organism));
  return;
}

void enter_the_train(train*tgv, o_pointer passenger, int wagon){
  int p = tgv->nr_passengers[wagon];
  if(p == tgv->size[wagon] * INITIAL_TRAIN_SIZE ){
    resize_train(tgv, wagon);
  }
  memcpy( &(tgv->passengers[wagon][p]), passenger, sizeof(organism) );
  tgv->nr_passengers[wagon]++;
  return;
}

void train_destruction(train*tgv){
  int i;
  for(i=0; i<8; i++){
    free(tgv->passengers[i]);
  }
  free(tgv);
  return;
}

void empty_train(train*tgv){
  int i;
  for(i=0; i<8; i++){
    tgv->nr_passengers[i] = 0;
  }
  return;
}

bool move_parallel(world*wrld, train*tgv, org_list*listing, int org_pos, int all_n){
  int direction, new_x, new_y;
  int leaving_direction = -1;
  o_pointer org = listing->list[org_pos];
  org->age++;
  if(org->pregnant) org->month++;
  decrease_density_at(wrld, org->x, org->y);
  direction = rand() % 8;
  new_x = org->x;
  new_y = org->y;
  switch(direction){
  case 0: 
    new_x--;
    new_y--;
    if(new_x < wrld->corner_x && new_y < wrld->corner_y){
      org->x = (new_x + all_n) % all_n;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 0;
    }else if(new_x < wrld->corner_x){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 7;      
    }else if(new_y < wrld->corner_y){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 1; 
    }
    break;
  case 1:
    new_x--;
    if(new_x < wrld->corner_x){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 7;
    }
    break;
  case 2:
    new_y--;
    if(new_y < wrld->corner_y){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 1; 
    }
    break;
  case 3:
    new_x++;
    new_y--;
    if(new_x > wrld->corner_x+wrld->n - 1 && new_y < wrld->corner_y){
      org->x = (new_x + all_n) % all_n;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 2;
    }else if(new_y < wrld->corner_y){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 1; 
    }else if(new_x > wrld->corner_x+wrld->n - 1){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 3;
    }
    break;
  case 4:
    new_x--;
    new_y++;
    if(new_y > wrld->corner_y+wrld->n -1 && new_x < wrld->corner_x){
      org->x = (new_x + all_n) % all_n;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 6;
    }else if(new_x < wrld->corner_x){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 7;
    }else if(new_y > wrld->corner_y+wrld->n -1){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 5;
    }
    break;
  case 5:
    new_x++;
    if(new_x > wrld->corner_x+wrld->n - 1){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 3;
    }
    break;
  case 6:
    new_y++;
    if(new_y > wrld->corner_y+wrld->n -1){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 5;
    }
    break;
  case 7:
    new_x++;
    new_y++;
    if(new_x > wrld->corner_x+wrld->n - 1 && new_y > wrld->corner_y+wrld->n -1){
      org->x = (new_x + all_n) % all_n;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 4;
    }else if(new_x > wrld->corner_x+wrld->n - 1){
      org->x = (new_x + all_n) % all_n;
      org->y = new_y;
      leaving_direction = 3;
    }else if(new_y > wrld->corner_y+wrld->n -1){
      org->x = new_x;
      org->y = (new_y + all_n) % all_n;
      leaving_direction = 5;
    }
    break;
  }
  if(leaving_direction >= 0){
    enter_the_train(tgv, org, leaving_direction);
    list_kill_organism(listing, org_pos);
    return(true);
  }else{
    org->x = new_x;
    org->y = new_y;
    increase_density_at(wrld, org->x, org->y);
    return(false);
  }
}

void move_all_parallel(world*wrld, train*tgv, int all_n){
  bool moving;
  int j, i;
  org_list * organisms;
  empty_train(tgv);
  for(i=0;i<2;i++){
    j=0;
    if(i){
      organisms = &(wrld->females);
    }else{
      organisms = &(wrld->males);
    }
    while(j < organisms->org_num){
      moving = move_parallel(wrld, tgv, organisms, j, all_n);
      if(!moving){
	j++;
      }
    }
  }
  return;
}

void set_free(world*wrld, o_pointer insert, int nr){
  int i;
  o_pointer org;
  for(i=0; i<nr; i++){
    org = malloc(sizeof(organism));
    memcpy(org, &(insert[i]), sizeof(organism));
    increase_density_at(wrld, org->x, org->y);
    if(female(org)){
      list_insert(&(wrld->females), org);
    }else{
      list_insert(&(wrld->males), org);
    }
  }
  free(insert);
  return;
}
