
#ifndef PARALLEL_ORG_H
#define PARALLEL_ORG_H

#include <string.h>
#include "org_and_env.h"
#include "config_and_coord.h"
#include "mpi.h"

#define INITIAL_TRAIN_SIZE (N_WORLD_SIZE*MAX_POPULATION_PER_FIELD) 

typedef struct{
  int size[8]; //how many organisms are sent to each direction
  int nr_passengers[8];
  o_pointer passengers[8];
}train;

train * build_a_train();

void enter_the_train(train*tgv, o_pointer passenger, int wagon);

void train_destruction(train*tgv);

void move_all_parallel(world*wrld, train*tgv, int all_n);

void set_free(world*wrld, o_pointer insert, int nr);

#endif
