
#ifndef PHENOTYPES_H
#define PHENOTYPES_H

#include <dirent.h>
#include "bmpfile.h"
#include "config_and_coord.h"
#include "org_and_env.h"

typedef struct{

  unsigned int x;
  unsigned int y;
  unsigned int total_nr_org;
  unsigned int phenotypes[NR_PHENOTYPES]; //has to be initialized, in config_and_coord.h

}population_information;


population_information* init_info(world* wrld, int field_size, int process_x, int process_y);

int simple_autosomal_dominant_recessive_phenotype(o_pointer org);

int autosomal_phenotypes(o_pointer org);

bool check_gene_phenotype(int type_nr, int gene_nr);

bool check_phenotype(o_pointer org, int gene_nr);

void get_info(int(*phenotype)(o_pointer org), world* wrld, population_information*info, int field_size);

void draw_bmp_plus(population_information*info, int size, int generation, int field_size, char*directory_name, int pixelsize);


#endif
